using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace M_C_V
{
    public abstract class MCV
    {
        public delegate void ClearHandler(object source, EventArgs e);
        public delegate void RefreshHandler(object source, EventArgs e);
        public delegate void EnableHandler(object source, EventArgs e);
        public delegate void DisableHandler(object source, DisableEventArgs e);
        public delegate void ResetHandler(object source, EventArgs e);
        public class DisableEventArgs : EventArgs
        {
            public readonly string Message = "";
            public DisableEventArgs(string message)
            {
                this.Message = message;
            }
        }
        public interface IViewable
        {
            bool Clear();
            bool Refresh();  // IViewable should store state for refresh
            bool Enable();
            bool Disable(string message);
            bool Reset(); // reset state to initial state
        }
        public interface IViewableEvents
        {
            DisableHandler GetDisableHandler();
            EnableHandler GetEnableHandler();
            ClearHandler GetClearHandler();
            RefreshHandler GetRefreshHandler();
            ResetHandler GetResetHandler();
        }
    } // end MCV class
}
